##############################################################################
## This file is part of 'SLAC Firmware Standard Library'.
## It is subject to the license terms in the LICENSE.txt file found in the 
## top-level directory of this distribution and at: 
##    https://confluence.slac.stanford.edu/display/ppareg/LICENSE.html. 
## No part of 'SLAC Firmware Standard Library', including this file, 
## may be copied, modified, propagated, or distributed except according to 
## the terms contained in the LICENSE.txt file.
##############################################################################

Device: &EvrV2Module
  name: EvrV2Module
  description: LCLS-II Timing Trigger module
  size: 0x800
  #########
  IntField:
  #########
        #########################################################
        - offset: 0x00
          name: IrqEnable
          sizeBits: 1
          mode: RW
          description: Interrupt Enable
        #########################################################
        - offset: 0x04
          name: IrqStatus
          sizeBits: 1
          mode: RO
          description: Interrupt Pending
        #########################################################
        - offset: 0x08
          name: LinkAddr
          sizeBits: 16
          mode: RO
          description: Physical link address
        #########################################################
        - offset: 0x0C
          name: gtxDebug
          sizeBits: 8
          mode: RO
          description: Debug bits from link
        #########################################################
        - offset: 0x10
          name: CountReset
          sizeBits: 1
          mode: RW
          description: Counter reset
        #########################################################
        - offset: 0x14
          name: ModeSel
          sizeBits: 1
          mode: RW
          description: Select LCLS-I/LCLS-II Trigger outputs (0/1)
        #########################################################
        - offset: 0x18
          name: DmaFullThr
          sizeBits: 24
          mode: RW
          description: Set threshold in bytes for asserting readout full
        #########################################################
        - offset: 0x20
          name: ChannelEnable
          sizeBits: 1
          lsBit: 0
          nelms: 12
          stride: 32
          mode: RW
          description: Enable readout channel
        #########################################################
        - offset: 0x20
          name: ChannelBsaEnable
          sizeBits: 1
          lsBit: 1
          nelms: 12
          stride: 32
          mode: RW
          description: Enable BSA channel
        #########################################################
        - offset: 0x20
          name: ChannelDmaEnable
          sizeBits: 1
          lsBit: 2
          nelms: 12
          stride: 32
          mode: RW
        #########################################################
        - offset: 0x24
          name: ChannelRateSel
          sizeBits: 13
          lsBit: 0
          nelms: 12
          stride: 32
          mode: RW
        #########################################################
        - offset: 0x25
          name: ChannelDestSel
          sizeBits: 18
          lsBit: 5
          nelms: 12
          stride: 32
          mode: RW
          description: Channel event destination selection
        #########################################################
        - offset: 0x28
          name: ChannelEventCnt
          sizeBits: 32
          nelms: 12
          stride: 32
          mode: RW
          description: Channel event counts
        #########################################################
        - offset: 0x2C
          name: ChannelBsaDelay
          sizeBits: 20
          lsBit: 0
          nelms: 12
          stride: 32
          mode: RW
          description: Channel BSA active delay
        #########################################################
        - offset: 0x2E
          name: ChannelBsaSetup
          sizeBits: 12
          lsBit: 4
          nelms: 12
          stride: 32
          mode: RW
          description: Channel BSA active setup
        #########################################################
        - offset: 0x30
          name: ChannelBsaWidth
          sizeBits: 20
          nelms: 12
          stride: 32
          mode: RW
          description: Channel BSA active width
        #########################################################
        - offset: 0x1A8
          name: GlobalEventCnt
          sizeBits: 32
          mode: RW
          description: Global Event count
        #########################################################
        - offset: 0x200
          name: TriggerChannel
          sizeBits: 4
          nelms: 12
          stride: 16
          mode: RW
          description: Channel used for event selection
        #########################################################
        - offset: 0x202
          name: TriggerPolarity
          sizeBits: 1
          lsBit: 0
          nelms: 12
          stride: 16
          mode: RW
          description: Trigger polarity (0=negative, 1=positive)
        #########################################################
        - offset: 0x203
          name: TriggerEnable
          sizeBits: 1
          lsBit: 7
          nelms: 12
          stride: 16
          mode: RW
          description: Trigger enable
        #########################################################
        - offset: 0x204
          name: TriggerDelay
          sizeBits: 28
          nelms: 12
          stride: 16
          mode: RW
          description: Trigger delay (186MHz clocks)
        #########################################################
        - offset: 0x208
          name: TriggerDelay
          sizeBits: 28
          nelms: 12
          stride: 16
          mode: RW
          description: Trigger width (186MHz clocks)
        #########################################################
        - offset: 0x20C
          name: TriggerFineDelay
          sizeBits: 6
          nelms: 12
          stride: 16
          mode: RW
          description: Trigger fine delay (82.2 ps steps)
        #########################################################
